SystemOrganization addCategory: #'PLP-TP3-Pokemon'!

Object subclass: #Tipo
	instanceVariableNames: 'nombre efectividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3-Pokemon'!

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:05'!
existeTipo: nombreTipo 
	Tipo
		iterateInstancesSearchFor: nombreTipo
		andDo: [:v | ^ true ]
		ifAbsent: [:v | ^ false ]! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:04'!
getInstance: nombreTipo
	Tipo
		iterateInstancesSearchFor: nombreTipo
		andDo: [ :val | ^ val ]
		ifAbsent: [ :nombre | ^ Tipo new initializeOnNombre: nombre ]! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/14/2012 00:05'!
iterateInstancesSearchFor: nombreTipo andDo: aBlock ifAbsent: anotherBlock
	Tipo
		allInstancesDo: [ :each | 
			each nombre = nombreTipo
				ifTrue: [ ^ aBlock value: each ] ].
	^ anotherBlock value: nombreTipo! !

!Tipo class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:42'!
new: nombreTipo

	Tipo getInstance: nombreTipo.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:57'!
efectividadContra: nombreTipo 

	^efectividades at: nombreTipo ifAbsent: 1! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:53'!
initializeOnNombre: nombreTipo 

	nombre := nombreTipo.
	efectividades := Dictionary new.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 23:46'!
nombre
	^nombre.! !
